Option Explicit
'Plasmatronics 2020.10.20

dim commport, sHeading
dim csvfile, sCsvFile, sPath

    commport = 1

    sHeading = "Time, Mode,Vbat,Vtarget,Vmax,Vmin,""State of Charge"",Charge current,Ah Daily Charge,Load Current,Ah Daily Load,Float time,Days since boost,Days since eq,Battery temperature,clock,volt,prog,<>,load state,generator state,event state,charge protection,alarm state,load protection,charge status,<>,solar voltage"

    sPath = CreateObject("Wscript.Shell").SpecialFolders("Mydocuments")
    sCSVfile = sPath & "\dstatus.csv"
    'sCSVfile = "C:\storage\dstatus.txt"

   Call RunIn32BitSystem	'restart script if required
   Call main(sCSVfile)


sub main(sCSVfile)
dim comm, fso
dim laFF00(16),laFF01(16),laB2(2) 'vbscript arrays are zero based, only the variant type is available
dim nCode,ErrCode,sErr, e, vNow
dim write_heading, write_URL
dim aData, i


    Set fso = CreateObject("Scripting.FileSystemObject")
	
    Set comm=CreateObject("NETCommOCX.NETComm")

    comm.CommPort = commport

    comm.Settings = "9600,E,8,1"
    comm.InputLen = 0		'return immediate
    comm.PortOpen = True

    wscript.sleep(20)	'doevents

	vNow=Now()
	e = get_dingo_status(laFF00,laFF01,laB2,Comm,nCode,sErr)

    comm.PortOpen = False

    if e=0 then
	adata= scale_dingo_status(laFF00,laFF01,laB2,errCode,sErr)
    end if
    

    if not fso.FileExists(scsvfile) Then 
	write_heading=true
    end if
	
    set csvfile = fso.opentextfile(scsvfile,8,true) 'append, create if missing
	if write_heading then csvfile.writeline(sHeading)
	csvfile.write( vNow)
	if (e=0) and (errCode=0) then
	    for i = 3 to ubound(adata)
	    	csvfile.write(", ")
	    	csvfile.write(adata(i))
	    next
	else 
	    csvfile.write(", ")
	    csvfile.write(e)
	    csvfile.write(", ")
	    csvfile.write(errcode)
	    csvfile.write(", ")
	    csvfile.write(sErr)
        end if
	csvfile.writeline

    csvfile.close

end sub

sub RunIn32BitSystem()
	If Is64BitOS() and wscript.arguments.count = 0 then
		if 0=instr(wscript.fullname,"SysWow64") then
			dim sscript,path,objShell

			if instr(lcase(WScript.FullName),"cscript") then sscript="cscript" else sscript="wscript"
			
			path = wscript.CreateObject("Shell.application").NameSpace("shell:Systemx86").self.path
			'path = "c:\Windows\SysWoW64"
			'shell.Systemx86 is also mapped to index 41.

			Set objShell = WScript.CreateObject("WScript.Shell")
			objShell.Run path & "\" & sscript & " """&  Wscript.ScriptFullName &""" """ & "InScript""", 0,True
			Set objShell = Nothing
			wscript.quit
		end if
	end if

end sub

Function Is64BitOS()
on error resume next	'AddressWidth property is not supported on WinXP
    Const Path = "winmgmts:root\cimv2:Win32_Processor='cpu0'"
    Is64BitOS = (GetObject(Path).AddressWidth = 64)
End Function
'======================================================
Function sCRC16(InString)
Dim crc          
Dim i, j , databyte 

    crc = &HFFFF&
    For i = 1 To Len(InString)
        databyte = Asc(Mid(InString, i, 1))
        crc = crc Xor databyte
        For j = 1 To 8
            If 1 = (crc And 1) Then
                crc = (crc \ 2) Xor &HA001&
            Else
                crc = (crc \ 2)
            End If
        Next 'j
    Next 'i
  
    i = crc \ 256
    j = crc And 255
    sCRC16 = Chr(j) & Chr(i)   '2012.05.30
End Function

Function sMBint(wValue)
Dim LO 'As Byte
Dim HI 'As Byte
    LO = wValue And &HFF&
    HI = (wValue And &HFF00&) \ 256
    sMBint = Chr(HI) + Chr(LO)
End Function

Function MBpacket(SlaveAddr, FuncCode, RegAddr, regCount)
Dim s 'As String
Dim sReg    'As String
Dim sNum    'As String

    sReg = sMBint(CInt(RegAddr))
    sNum = sMBint(regCount)
    
    s = Chr(SlaveAddr) + Chr(funcCode) + sReg + sNum

    s = s & sCRC16(s)

    MBpacket = s

End Function

'======================================================

'======================================================
Function sGetMBdata(nSlaveAddr, nRegAddr, nRegCount, sProtocol,Comm, errCode, sErr)
Dim i 
Dim strData 
Dim nSum
dim loopcount 
dim expected_count
dim maxLength 
dim nRecv
dim nDataLen, nRecvSlave, nRecvFunc
dim nFuncCode

    nFuncCode=3
Do
    i = i + 1

    If sProtocol = "MBRTU" Then
	strData = MBpacket(nSlaveAddr, nFuncCode, nRegAddr, nRegCount)
    	expected_count = 5 + (nRegCount * 2)
    	maxLength = expected_count
	
    Else
        exit function
    End If

    Comm.InBufferCount = 0	'clear

    Comm.Output= strData

    Do
	wscript.sleep(200)	'DoEvents
        loopcount = loopcount + 1
    Loop until (Comm.InBufferCount >= maxLength) or (loopcount > 5)


    strData = Comm.inputData	'comm wrapper uses "inputdata" instead of "input"
    nRecv = len(strData)

        If (nRecv < 1) Then
            errCode = nRecv
        Else
            If nRecv >= 3 Then
                nDataLen = asc(mid(strData,3,1))
                nRecvSlave = asc(mid(strData,1,1))
                nRecvFunc = asc(mid(strData,2,1))
            End If
            If (nRecvFunc And 127) <> nFuncCode Then
                sErr = "Comms error: unexpected reply: " & nRecvFunc & " as MB function."
                errCode = -1
            ElseIf (nSlaveAddr <> nRecvSlave) Then
                sErr = "Comms error: unexpected reply: " & nSlaveAddr & " as MB device address."
                errCode = -1
            ElseIf (nRecvFunc And 128) = 128 Then
                errCode = strData(3)
                Select Case errCode
                    Case 1: sErr = "Gateway Reports " & MBXcode01
                    Case 2: sErr = "Gateway Reports " & MBXcode02 & " (&H" & Hex(RegAddr) & ")"
                    Case 3: sErr = "Gateway Reports " & MBXcode03 & " (generic error or Dingo not connected), request was: " & sHexStr(strSend)
                    Case 4: sErr = "Gateway Reports " & MBXcode04
                    Case Else: sErr = "DNET MB error code " & errCode
                End Select
                errCode = -errCode
            ElseIf nRecv <> maxLength Then
                sErr = "Error, unexpected serial reply: received " & nRecv & " expected " & maxLength & " bytes."
                errCode = -1
            ElseIf nregCount * 2 <> nDataLen Then
                sErr = "Error, unexpected serial reply: received " & nDataLen & " expected " & regCount * 2 & " data bytes."
                errCode = -1
            Else
                errCode = nRecv
            End If
        End If

    'wscript.echo vartype(strdata)
    'wscript.echo strdata
    'wscript.echo errCode
    'wscript.echo serr

    if len(strData) > 5 then
    	strData = right(strData,len(strData)-3)
    	sGetMBdata = left(strData,len(strData) - 2)
    end if

Loop Until (i > 4) Or (errCode > 0)   
    
End Function


function get_dingo_status(laFF00,laFF01,laB2,Comm, errcode, sErr)
Dim j
Dim s1,s2,strData

    get_dingo_status = 0

    strData = sGetMBdata(8, &HFF00, 16, "MBRTU",Comm, errCode, sErr)
    
    if (errcode>0) and (vartype(strData) = vbString) and (len(strData) = 32) then
    For j = 1 to 16	
	s1 = mid(strData,j*2)
	laFF00(j) = asc(s1)
    Next
    else 
	'wscript.echo "a",errcode,serr,strdata
	get_dingo_status=-1
	exit function
    end if

    strData = sGetMBdata(8, &HFF01, 16, "MBRTU",Comm, errCode, sErr)

    if (errcode>0) and (vartype(strData) = vbString) and (len(strData) = 32) then
    For j = 1 to 16 	'1 to n
	s1 = mid(strData,j*2)
	laFF01(j) = asc(s1)
    Next
    else 
	'wscript.echo "b",errcode,serr,strdata
	get_dingo_status=-1
	exit function
    end if

    strData = sGetMBdata(8, &HB2, 1, "MBRTU",Comm, errCode, sErr)

    if (errcode>0) and (vartype(strData) = vbString) and (len(strData) = 2) then
    For j = 1 to 1 	'1 to n
	s1 = mid(strData,j*2)
	laB2(j) = asc(s1)
    Next
    else 
	'wscript.echo "c", errcode,serr,strdata
	get_dingo_status=-1
	exit function
    end if


end function

function scale_dingo_status(laFF00 , laFF01, laB2, errcode, sErr)
Dim temp
Dim batv, vmult,svdelta
Dim volt, stat
Dim voltIndex, statIndex
volt = Array(12, 24, 32, 36, 48, 0)
stat = Array("boost", "equl", "absb", "float", "ERROR")

dim aData(30)

    errCode = 0
    'aData(0) = Now()    

    statIndex = (laFF00(14) \ &H40) And &H3
    If statIndex > UBound(stat) Then
        statIndex = UBound(stat)
        If errcode = 0 Then
            errcode = -1
            sErr = "Data Error"
        End If
    End If
    
    voltIndex = laFF00(1) And &HF
    If voltIndex > UBound(volt) Then
        voltIndex = UBound(volt)
        If errcode = 0 Then
            errcode = -2
            sErr = "Data Error"
        End If
    End If
    

    vmult = volt(voltIndex) / 12.0
    batv = ((laFF00(5)*256.0) + laFF00(6)) / 10.0
    

    temp = laFF00(4)                                    'Battery temperature
    If temp = 128 Then temp = ""

    aData(3) = stat(statIndex)    		'Regulator Mode state ((laFF00(14) \ &H40) And &H3)
    aData(4) = batv     			'Battery voltage (laFF00(5), laFF00(6))
    aData(5) = vmult * laFF00(7) / 10        		'Regulation target voltage
    aData(6) = vmult * laFF00(12) / 10 			'Day max battery voltage
    aData(7) = vmult * laFF00(13) / 10 			'Day min battery voltage
    aData(8) = laFF00(11)        			'State of Charge
    aData(9)  =((laFF01( 1) * 256) + laFF01( 2) + (laFF01( 9) * 256) + laFF01(10)) / 10 'charge current
    aData(10) = (laFF01(11) * 256) + laFF01(12)	'AH charge
    aData(11) =((laFF01( 5) * 256) + laFF01( 6) + (laFF01(13) * 256) + laFF01(14))/ 10 	'load current
    aData(12) = (laFF01(15) * 256) + laFF01(16)	'AH
    if laFF00(10) <= 241 then
     	aData(13) = cdate(laFF00(10) * 6 / 1440)  	'Clock time we went into float
    else
	aData(13) = ""
    end if
    aData(14) = laFF00(9)              		'Days since last boost
    aData(15) = laFF00(8)              		'Days since equalization
    aData(16) = temp				'temperature (laFF00(4))
    aData(17) = cdate(((laFF00(3) * 6) + laFF00(2)) / 1440) 'clock
    aData(18) = volt(voltIndex)      		'VOLT setting value (laFF00(1) And &HF)
    aData(19) = (laFF00(1) And &HF0) \ &H10    'PROG setting value
        
    aData(21) = (laFF00(14)) And 1             'Load State
    aData(22) = (laFF00(14) \ &H2) And 1       'Generator State
    aData(23) = (laFF00(14) \ &H4) And 1       'Event controller state
    aData(24) = (laFF00(14) \ &H8) And 1       'Charge protection state
    aData(25) = (laFF00(14) \ &H10) And 1      'Alarm State
    aData(26) = (laFF00(14) \ &H20) And 1      'Load protection state
    aData(27) = (laFF00(14) \ &H40) And &H3    'Regulator Mode state
    
    svdelta = (laB2(1) * 256) + laB2(2)        'solar voltage
    If svdelta < 28 Then
        aData(29) = 0
    Else
        aData(29)= batv + (svdelta / 10)       'solar voltage
    End If

    scale_dingo_status = aData

End function

